# This code is copyrighted by iuveno AG in January, 2001.
#
# written by Stephan Richter
# Last updated: February 4, 2001

class ActionTriggerSupport:
    '''ActionTriggerSupport class - class adds support for action triggers'''

    def _beforeAdd(self, parent=None, request=None):
        '''_beforeAdd(self, parent=None, request=None) --> Method executed before the object is added to the ZODB;
           object-specific initializations can be done here; return None'''
        self.beforeAdd(parent, request)


    def _afterAdd(self, parent=None, request=None):
        '''_afterAdd(self, parent=None, request=None) --> Method executed after the object was added to the ZODB;
           object-specific initializations are done here; return None'''
        self.afterAdd(parent, request)


    def _beforeEdit(self, parent=None, request=None):
        '''_beforeEdit(self, parent=None, request=None) --> Method executed before the object is edited in the ZODB;
           return None'''
        self.beforeEdit(parent, request)


    def _afterEdit(self, parent=None, request=None):
        '''_afterEdit(self, parent=None, request=None) --> Method executed after the object was edited in the ZODB;
           return None'''
        self.afterEdit(parent, request)


    def _beforeDelete(self, parent=None, request=None):
        '''_beforeDelete(self, parent=None, request=None) --> Method executed before the object is deleted in the ZODB;
           return None'''
        self.beforeDelete(parent, request)


    def _afterDelete(self, parent=None, request=None):
        '''_afterDelete(self, parent=None, request=None) --> Method executed after the object was deleted in the ZODB;
           return None'''
        self.afterDelete(parent, request)


    ### start of public API interface ###

    def beforeAdd(self, parent=None, request=None):
        '''beforeAdd(self, parent=None, request=None) --> Public method to add tasks that are executed before the
           object is added to the ZODB; return None'''
        pass


    def afterAdd(self, parent=None, request=None):
        '''afterAdd(self, parent=None, request=None) --> Public method to add tasks that are executed after the
           object was added to the ZODB; return None'''
        pass


    def beforeEdit(self, parent=None, request=None):
        '''beforeEdit(self, parent=None, request=None) --> Public method to add tasks that are executed before the
           object is edited in the ZODB; return None'''
        pass


    def afterEdit(self, parent=None, request=None):
        '''afterEdit(self, parent=None, request=None) --> Public method to add tasks that are executed after the
           object was edited in the ZODB; return None'''
        pass


    def beforeDelete(self, parent=None, request=None):
        '''beforeDelete(self, parent=None, request=None) --> Public method to add tasks that are executed before the
           object is deleted from the ZODB; return None'''
        pass


    def afterDelete(self, parent=None, request=None):
        '''afterDelete(self, parent=None, request=None) --> Public method to add tasks that are executed after the
           object was deleted from the ZODB; return None'''
        pass


