# This code is copyrighted by bluedynamics.com in June, 2001.
#
# written by Stephan Richter
# Last updated: June 5, 2001

from DBTable                     import DBTable, DBAttribute 
from FolderishDBObject           import FolderishDBObject
from DBObjectFolder              import DBObjectFolder
from DBObjectSQLContainerSupport import DBObjectSQLContainerSupport
from Globals                     import HTMLFile


manage_addDemoObjectFolderForm = HTMLFile('dtml/demoObjectFolder_manageAddForm', globals())

def manage_addDemoObjectFolder(self, id, title='', REQUEST=None):
    '''manage_addDemoObjectFolder(self, id, title="", artifactPath="", REQUEST=None)
       --> add a new DemoObject Folder; return None or HTML'''

    # make sure the id is a string, otherwise nothing will work
    id    = str(id)
    title = str(title)

    # initialize the new DemoObjectFolder
    pf = DemoObjectFolder(self, id, title)

    # add the object to the ZODB
    self._setObject(id, pf)

    self._getOb(id)._afterAdd(self, REQUEST)

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)



class DemoObject(FolderishDBObject):
    '''DemoObject class -  contains/manages data associated with a DemoObject'''

    isVolatile = 1
    meta_type = 'DemoObject'
    icon = 'misc_/DBObjects/project'

    dbTable = (DBTable('DemoObject', [],
                       {'name'        : DBAttribute('name',        'varchar(255)'),
                        'description' : DBAttribute('description', 'text'        )})
               + FolderishDBObject.dbTable)

    allowedSubObjects = ('DemoSubObjectFolder',)

    manageRoles = ('ManageDemoObject%(demoobjectid)s',)
    viewRoles   = ('ViewDemoObject%(demoobjectid)s',)


    def getDemoObjectId(self):
        '''getDemoObjectId(self) --> get the id of the object; return string'''
        return self.id



class DemoObjectFolder(DBObjectFolder, DBObjectSQLContainerSupport):
    '''DemoObjectFolder class - contains all DemoObjects for one project.'''

    meta_type = 'DemoObjectFolder'  
    icon = 'misc_/DBObjects/projectFolder'
    
    allowedSubObjects = ('DemoObject',)

    manageRoles = ('ManageDemoObjects',)
    viewRoles   = ('ViewDemoObjects',)

    manage_options = ( DBObjectFolder.manage_options
                       + DBObjectSQLContainerSupport.manage_options )

    connectionID         = 'dbConnection'
    isSQLMethodContainer = 1
    isRoleSupportRoot    = 1



