# This code is copyrighted by bluedynamics.com in June, 2001.
#
# written by Stephan Richter
# Last updated: June 5, 2001

from DBObjectFolder    import DBObjectFolder
from DBObject          import DBObject
from DBTable           import DBTable, DBAttribute 


class DemoSubObject(DBObject):
    '''DemoSubObject class - contains/manages data associated with a DemoSubObject'''

    isVolatile = 1
    meta_type = 'DemoSubObject'
    icon = 'misc_/DBObjects/message'

    dbTable = (DBTable('DemoSubObject', [],
                       {'name'         : DBAttribute('name',         'varchar(255)', ),
                        'body'         : DBAttribute('body',         'text'          ),
                        'date_created' : DBAttribute('date_created', 'timestamp'     )})
               + DBObject.dbTable);

    titleDBRepresentation = 'name'

    manageRoles = ('ManageDemoSubObject%(demosubobjectid)s',)
    viewRoles   = ('ViewDemoSubObject%(demosubobjectid)s',)
        

class DemoSubObjectFolder(DBObjectFolder):
    '''DemoSubObjectFolder class - contains all projects for one site.'''

    isVolatile = 1
    meta_type = 'DemoSubObjectFolder' 
    icon = 'misc_/DBObjects/messageFolder'

    allowedSubObjects = ('DemoSubObject',)

    manageRoles = ('ManageDemoSubObjects',)
    viewRoles   = ('ViewDemoSubObjects',)
